name: REST and frontends
description: Build a craft beer rating app
depend: quasar
goals:
    rest: 1
resources:
    From Frontend to API:
        - link: https://www.frontendmentor.io/articles/integrating-with-apis-a-beginners-guide-for-frontend-developers-u_xfEadBc-
          title: Integrating with APIs
          info: Using (REST) APIs from the perspective of a frontend developer
        - link: https://router.vuejs.org/guide/advanced/data-fetching
          title: Data Fetching (Vue Documentation)
          info: Ways of fetching data in Vue
assignment:
    - Assignment:
          - |
              We'll be using the solution you created in the previous assignment.
              Copy the files from the previous assignment into the backend folder from the template.
              
              In this assignment we'll introduce a frontend for our backend. To keep things separated we'll be working from two folders.

    - REST & Frontends:
          - |
              The purpose of a REST API is to securely provide access to information over the internet.
              Where a traditional website returns HTML which is turned into a human readable information, REST APIs can provide the same information that is easier to parse by computers.
              The benefit is that you can separate the business logic from the visual representation of the data. The rest API doesn't need to care about how the information will be presented to the user, it jus needs to make its information and functions available through the API.
              This makes it incredibly useful for creating services that work across multiple platforms. Like web, mobile, smart TV, smart watch, desktop or car.

              In this assignment we'll create a simple frontend that utilizes our craft beer REST API.
    - Craft Beer Rating App:
          - ^merge: feature
            text: |
                <wired-card style="width: 100%; box-sizing: border-box">
                    <h1>Beers</h1>
                    <wired-card style="width: 95%;">
                        <h4>Augustijn Blond</h4>
                        <p>Alcohol: 7.0%</p>
                    </wired-card>
                    <wired-card style="width: 95%;">
                        <h4>Viven Imperial IPA</h4>
                        <p>Alcohol: 7.0%</p>
                    </wired-card>
                    <wired-card style="width: 95%;">
                        <h4>Blanche de Namur</h4>
                        <p>Alcohol: 7.0%</p>
                    </wired-card>
                    <wired-card style="width: 95%;">
                        <h4>Brugse Zot Dubbel</h4>
                        <p>Alcohol: 7.0%</p>
                    </wired-card>
                    <wired-divider></wired-divider>
                    <div style="text-align: center">
                        <wired-button disabled style="width: auto; display: inline-block">Beers</wired-button>
                    </div>
                </wired-card>

                <script>loadScript("/static/wired-elements.js")</script>

                The readme.md file in the frontend folder includes instructions on how to setup a template quasar project.

                Once its been setup you can run the app using `npm run dev`.

                Create a "Beers" tab, fetch all the beers from your API, and display them in a list.

                Since we're using Quasar, you can use the `onMounted` run code (e.g: Fetch data) whenever the user navigates to another page.
                To fetch your data you can use the `fetch` function in Javascript.

                Make sure the list visually shows when it is loading, or when there's an error.
          - ^merge: feature
            text: |
                <wired-card style="width: 100%; box-sizing: border-box">
                    <h1>Profile</h1>
                    <wired-card style="width: 95%;">
                        <h4>Login</h4>
                        <p>Username:</p>
                        <wired-input></wired-input>
                        <p>Password:</p>
                        <wired-input></wired-input>
                    </wired-card>
                    <br/>
                    <br/>
                    <br/>
                    <br/>
                    <wired-divider></wired-divider>
                    <div style="text-align: center">
                        <wired-button style="width: auto; display: inline-block">Beers</wired-button>
                        <wired-button disabled style="width: auto; display: inline-block">Profile</wired-button>
                    </div>
                </wired-card>

                <wired-card style="width: 100%; box-sizing: border-box">
                    <h1>Profile</h1>
                    <wired-card style="width: 95%;">
                        <h4>Welcome back</h4>
                        <p>Here you'll find your favorite beers.</p>
                    </wired-card>
                    <wired-divider></wired-divider>
                    <wired-card style="width: 95%;">
                        <h4>Blanche de Namur</h4>
                        <p>Alcohol: 7.0%</p>
                    </wired-card>
                    <wired-card style="width: 95%;">
                        <h4>Brugse Zot Dubbel</h4>
                        <p>Alcohol: 7.0%</p>
                    </wired-card>
                    <wired-divider></wired-divider>
                    <div style="text-align: center">
                        <wired-button style="width: auto; display: inline-block">Beers</wired-button>
                        <wired-button disabled style="width: auto; display: inline-block">Profile</wired-button>
                    </div>
                </wired-card>

                <script>loadScript("/static/wired-elements.js")</script>

                Add a profile page, on this page e can list the user's favorite beers.
                Before a user can see this personal selection they'll need to login with a username and password.

                After a successful login, a similar list to the beers page should be shown but only including the user's favorite beers.

                If the login fails, an appropriate message should be shown in the login form.

                **Hint:** In order to make requests for a specific user, you'll need the JWT token that you receive after a successful login. You can store the JWT token after login in local storage for future requests.
          - ^merge: feature
            text: |
                <wired-card style="width: 100%; box-sizing: border-box">
                    <h1>Beers</h1>
                    <wired-card style="width: 95%;">
                        <div style="display: inline-block">
                            <h4>Augustijn Blond</h4>
                            <p>Alcohol: 7.0%</p>
                        </div>
                        <wired-button style="display: inline-block; float:right">&#9825;</wired-button>
                    </wired-card>
                    <wired-card style="width: 95%;">
                        <div style="display: inline-block">
                            <h4>Viven Imperial IPA</h4>
                            <p>Alcohol: 7.0%</p>
                        </div>
                        <wired-button style="display: inline-block; float:right">&#9829;</wired-button>
                    </wired-card>
                    <wired-card style="width: 95%;">
                        <div style="display: inline-block">
                            <h4>Blanche de Namur</h4>
                            <p>Alcohol: 7.0%</p>
                        </div>
                        <wired-button style="display: inline-block; float:right">&#9825;</wired-button>
                    </wired-card>
                    <wired-card style="width: 95%;">
                        <div style="display: inline-block">
                            <h4>Brugse Zot Dubbel</h4>
                            <p>Alcohol: 7.0%</p>
                        </div>
                        <wired-button style="display: inline-block; float:right">&#9825;</wired-button>
                    </wired-card>
                    <wired-divider></wired-divider>
                    <div style="text-align: center">
                        <wired-button disabled style="width: auto; display: inline-block">Beers</wired-button>
                        <wired-button style="width: auto; display: inline-block">Profile</wired-button>
                    </div>
                </wired-card>

                <wired-card style="width: 100%; box-sizing: border-box">
                    <h1>Profile</h1>
                    <wired-card style="width: 95%;">
                        <h4>Welcome back</h4>
                        <p>Here you'll find your favorite beers.</p>
                    </wired-card>
                    <wired-divider></wired-divider>
                    <wired-card style="width: 95%;">
                        <div style="display: inline-block">
                            <h4>Viven Imperial IPA</h4>
                            <p>Alcohol: 7.0%</p>
                        </div>
                        <wired-button style="display: inline-block; float:right">&#9829;</wired-button>
                    </wired-card>
                    <br/>
                    <br/>
                    <br/>
                    <br/>
                    <wired-divider></wired-divider>
                    <div style="text-align: center">
                        <wired-button style="width: auto; display: inline-block">Beers</wired-button>
                        <wired-button disabled style="width: auto; display: inline-block">Profile</wired-button>
                    </div>
                </wired-card>

                <script>loadScript("/static/wired-elements.js")</script>

                Currently, users can't change their favorite beers within the app. Let's add a button to each beer entry to mark it as a favorite beer.
                This should send a request to your backend to add/remove the beer as a favorite for this user.
                Then when we go back to the profile page, we should see our newly added favorite beers.
